    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------
    028     * PointerNeedle.java
    029     * ------------------
    030     * (C) Copyright 2002-2005, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: PointerNeedle.java,v 1.4.2.2 2005/10/25 20:50:49 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 26-Mar-2003 : Implemented Serializable (DG);
    042     * 09-Sep-2003 : Added equals() method (DG);
    043     * 08-Jun-2005 : Implemented Cloneable (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart.needle;
    048
    049    import java.awt.Graphics2D;
    050    import java.awt.geom.GeneralPath;
    051    import java.awt.geom.Point2D;
    052    import java.awt.geom.Rectangle2D;
    053    import java.io.Serializable;
    054
    055    /**
    056     * A needle in the shape of a pointer, for use with the
    057     * {@link org.jfree.chart.plot.CompassPlot} class.
    058     *
    059     * @author Bryan Scott
    060     */
    061    public class PointerNeedle extends MeterNeedle
    062                               implements Cloneable, Serializable {
    063
    064        /** For serialization. */
    065        private static final long serialVersionUID = -4744677345334729606L;
    066
    067        /**
    068         * Draws the needle.
    069         *
    070         * @param g2  the graphics device.
    071         * @param plotArea  the plot area.
    072         * @param rotate  the rotation point.
    073         * @param angle  the angle.
    074         */
    075        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    076                                  Point2D rotate, double angle) {
    077
    078            GeneralPath shape1 = new GeneralPath();
    079            GeneralPath shape2 = new GeneralPath();
    080            float minX = (float) plotArea.getMinX();
    081            float minY = (float) plotArea.getMinY();
    082            float maxX = (float) plotArea.getMaxX();
    083            float maxY = (float) plotArea.getMaxY();
    084            float midX = (float) (minX + (plotArea.getWidth() / 2));
    085            float midY = (float) (minY + (plotArea.getHeight() / 2));
    086
    087            shape1.moveTo(minX, midY);
    088            shape1.lineTo(midX, minY);
    089            shape1.lineTo(maxX, midY);
    090            shape1.closePath();
    091
    092            shape2.moveTo(minX, midY);
    093            shape2.lineTo(midX, maxY);
    094            shape2.lineTo(maxX, midY);
    095            shape2.closePath();
    096
    097            if ((rotate != null) && (angle != 0)) {
    098                /// we have rotation huston, please spin me
    099                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    100                shape1.transform(getTransform());
    101                shape2.transform(getTransform());
    102            }
    103
    104            if (getFillPaint() != null) {
    105                g2.setPaint(getFillPaint());
    106                g2.fill(shape1);
    107            }
    108
    109            if (getHighlightPaint() != null) {
    110                g2.setPaint(getHighlightPaint());
    111                g2.fill(shape2);
    112            }
    113
    114            if (getOutlinePaint() != null) {
    115                g2.setStroke(getOutlineStroke());
    116                g2.setPaint(getOutlinePaint());
    117                g2.draw(shape1);
    118                g2.draw(shape2);
    119            }
    120        }
    121
    122        /**
    123         * Tests another object for equality with this object.
    124         *
    125         * @param obj  the object to test (<code>null</code> permitted).
    126         *
    127         * @return A boolean.
    128         */
    129        public boolean equals(Object obj) {
    130            if (obj == this) {
    131                return true;
    132            }
    133            if (!(obj instanceof PointerNeedle)) {
    134                return false;
    135            }
    136            if (!super.equals(obj)) {
    137                return false;
    138            }
    139            return true;
    140        }
    141
    142        /**
    143         * Returns a clone of this needle.
    144         *
    145         * @return A clone.
    146         */
    147        public Object clone() throws CloneNotSupportedException {
    148            return super.clone();
    149        }
    150
    151    }